package com.dhcc.finance.main.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CwBdVouchtempExample {
    /**
     * cw_bd_vouchtemp
     */
    protected String orderByClause;

    /**
     * cw_bd_vouchtemp
     */
    protected boolean distinct;

    /**
     * cw_bd_vouchtemp
     */
    protected List<Criteria> oredCriteria;

    /**
     *
     * @mbg.generated 2019-07-31
     */
    public CwBdVouchtempExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    /**
     *
     * @mbg.generated 2019-07-31
     */
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    /**
     *
     * @mbg.generated 2019-07-31
     */
    public String getOrderByClause() {
        return orderByClause;
    }

    /**
     *
     * @mbg.generated 2019-07-31
     */
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    /**
     *
     * @mbg.generated 2019-07-31
     */
    public boolean isDistinct() {
        return distinct;
    }

    /**
     *
     * @mbg.generated 2019-07-31
     */
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    /**
     *
     * @mbg.generated 2019-07-31
     */
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    /**
     *
     * @mbg.generated 2019-07-31
     */
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    /**
     *
     * @mbg.generated 2019-07-31
     */
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    /**
     *
     * @mbg.generated 2019-07-31
     */
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    /**
     *
     * @mbg.generated 2019-07-31
     */
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * cw_bd_vouchtemp 2019-07-31
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andPkVouchtempIsNull() {
            addCriterion("PK_VOUCHTEMP is null");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempIsNotNull() {
            addCriterion("PK_VOUCHTEMP is not null");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP =", value, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempNotEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP <>", value, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempGreaterThan(String value) {
            addCriterion("PK_VOUCHTEMP >", value, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempGreaterThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP >=", value, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempLessThan(String value) {
            addCriterion("PK_VOUCHTEMP <", value, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempLessThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP <=", value, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempLike(String value) {
            addCriterion("PK_VOUCHTEMP like", value, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempNotLike(String value) {
            addCriterion("PK_VOUCHTEMP not like", value, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempIn(List<String> values) {
            addCriterion("PK_VOUCHTEMP in", values, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempNotIn(List<String> values) {
            addCriterion("PK_VOUCHTEMP not in", values, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBetween(String value1, String value2) {
            addCriterion("PK_VOUCHTEMP between", value1, value2, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempNotBetween(String value1, String value2) {
            addCriterion("PK_VOUCHTEMP not between", value1, value2, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeIsNull() {
            addCriterion("PK_SUBJSCHEME is null");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeIsNotNull() {
            addCriterion("PK_SUBJSCHEME is not null");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeEqualTo(String value) {
            addCriterion("PK_SUBJSCHEME =", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeNotEqualTo(String value) {
            addCriterion("PK_SUBJSCHEME <>", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeGreaterThan(String value) {
            addCriterion("PK_SUBJSCHEME >", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeGreaterThanOrEqualTo(String value) {
            addCriterion("PK_SUBJSCHEME >=", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeLessThan(String value) {
            addCriterion("PK_SUBJSCHEME <", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeLessThanOrEqualTo(String value) {
            addCriterion("PK_SUBJSCHEME <=", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeLike(String value) {
            addCriterion("PK_SUBJSCHEME like", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeNotLike(String value) {
            addCriterion("PK_SUBJSCHEME not like", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeIn(List<String> values) {
            addCriterion("PK_SUBJSCHEME in", values, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeNotIn(List<String> values) {
            addCriterion("PK_SUBJSCHEME not in", values, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeBetween(String value1, String value2) {
            addCriterion("PK_SUBJSCHEME between", value1, value2, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeNotBetween(String value1, String value2) {
            addCriterion("PK_SUBJSCHEME not between", value1, value2, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andCodeIsNull() {
            addCriterion("CODE is null");
            return (Criteria) this;
        }

        public Criteria andCodeIsNotNull() {
            addCriterion("CODE is not null");
            return (Criteria) this;
        }

        public Criteria andCodeEqualTo(String value) {
            addCriterion("CODE =", value, "code");
            return (Criteria) this;
        }

        public Criteria andCodeNotEqualTo(String value) {
            addCriterion("CODE <>", value, "code");
            return (Criteria) this;
        }

        public Criteria andCodeGreaterThan(String value) {
            addCriterion("CODE >", value, "code");
            return (Criteria) this;
        }

        public Criteria andCodeGreaterThanOrEqualTo(String value) {
            addCriterion("CODE >=", value, "code");
            return (Criteria) this;
        }

        public Criteria andCodeLessThan(String value) {
            addCriterion("CODE <", value, "code");
            return (Criteria) this;
        }

        public Criteria andCodeLessThanOrEqualTo(String value) {
            addCriterion("CODE <=", value, "code");
            return (Criteria) this;
        }

        public Criteria andCodeLike(String value) {
            addCriterion("CODE like", value, "code");
            return (Criteria) this;
        }

        public Criteria andCodeNotLike(String value) {
            addCriterion("CODE not like", value, "code");
            return (Criteria) this;
        }

        public Criteria andCodeIn(List<String> values) {
            addCriterion("CODE in", values, "code");
            return (Criteria) this;
        }

        public Criteria andCodeNotIn(List<String> values) {
            addCriterion("CODE not in", values, "code");
            return (Criteria) this;
        }

        public Criteria andCodeBetween(String value1, String value2) {
            addCriterion("CODE between", value1, value2, "code");
            return (Criteria) this;
        }

        public Criteria andCodeNotBetween(String value1, String value2) {
            addCriterion("CODE not between", value1, value2, "code");
            return (Criteria) this;
        }

        public Criteria andNameIsNull() {
            addCriterion("NAME is null");
            return (Criteria) this;
        }

        public Criteria andNameIsNotNull() {
            addCriterion("NAME is not null");
            return (Criteria) this;
        }

        public Criteria andNameEqualTo(String value) {
            addCriterion("NAME =", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotEqualTo(String value) {
            addCriterion("NAME <>", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameGreaterThan(String value) {
            addCriterion("NAME >", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameGreaterThanOrEqualTo(String value) {
            addCriterion("NAME >=", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLessThan(String value) {
            addCriterion("NAME <", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLessThanOrEqualTo(String value) {
            addCriterion("NAME <=", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLike(String value) {
            addCriterion("NAME like", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotLike(String value) {
            addCriterion("NAME not like", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameIn(List<String> values) {
            addCriterion("NAME in", values, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotIn(List<String> values) {
            addCriterion("NAME not in", values, "name");
            return (Criteria) this;
        }

        public Criteria andNameBetween(String value1, String value2) {
            addCriterion("NAME between", value1, value2, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotBetween(String value1, String value2) {
            addCriterion("NAME not between", value1, value2, "name");
            return (Criteria) this;
        }

        public Criteria andAbstractsIsNull() {
            addCriterion("ABSTRACTS is null");
            return (Criteria) this;
        }

        public Criteria andAbstractsIsNotNull() {
            addCriterion("ABSTRACTS is not null");
            return (Criteria) this;
        }

        public Criteria andAbstractsEqualTo(String value) {
            addCriterion("ABSTRACTS =", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsNotEqualTo(String value) {
            addCriterion("ABSTRACTS <>", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsGreaterThan(String value) {
            addCriterion("ABSTRACTS >", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsGreaterThanOrEqualTo(String value) {
            addCriterion("ABSTRACTS >=", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsLessThan(String value) {
            addCriterion("ABSTRACTS <", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsLessThanOrEqualTo(String value) {
            addCriterion("ABSTRACTS <=", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsLike(String value) {
            addCriterion("ABSTRACTS like", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsNotLike(String value) {
            addCriterion("ABSTRACTS not like", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsIn(List<String> values) {
            addCriterion("ABSTRACTS in", values, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsNotIn(List<String> values) {
            addCriterion("ABSTRACTS not in", values, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsBetween(String value1, String value2) {
            addCriterion("ABSTRACTS between", value1, value2, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsNotBetween(String value1, String value2) {
            addCriterion("ABSTRACTS not between", value1, value2, "abstracts");
            return (Criteria) this;
        }

        public Criteria andPkVouchertypeIsNull() {
            addCriterion("PK_VOUCHERTYPE is null");
            return (Criteria) this;
        }

        public Criteria andPkVouchertypeIsNotNull() {
            addCriterion("PK_VOUCHERTYPE is not null");
            return (Criteria) this;
        }

        public Criteria andPkVouchertypeEqualTo(String value) {
            addCriterion("PK_VOUCHERTYPE =", value, "pkVouchertype");
            return (Criteria) this;
        }

        public Criteria andPkVouchertypeNotEqualTo(String value) {
            addCriterion("PK_VOUCHERTYPE <>", value, "pkVouchertype");
            return (Criteria) this;
        }

        public Criteria andPkVouchertypeGreaterThan(String value) {
            addCriterion("PK_VOUCHERTYPE >", value, "pkVouchertype");
            return (Criteria) this;
        }

        public Criteria andPkVouchertypeGreaterThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHERTYPE >=", value, "pkVouchertype");
            return (Criteria) this;
        }

        public Criteria andPkVouchertypeLessThan(String value) {
            addCriterion("PK_VOUCHERTYPE <", value, "pkVouchertype");
            return (Criteria) this;
        }

        public Criteria andPkVouchertypeLessThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHERTYPE <=", value, "pkVouchertype");
            return (Criteria) this;
        }

        public Criteria andPkVouchertypeLike(String value) {
            addCriterion("PK_VOUCHERTYPE like", value, "pkVouchertype");
            return (Criteria) this;
        }

        public Criteria andPkVouchertypeNotLike(String value) {
            addCriterion("PK_VOUCHERTYPE not like", value, "pkVouchertype");
            return (Criteria) this;
        }

        public Criteria andPkVouchertypeIn(List<String> values) {
            addCriterion("PK_VOUCHERTYPE in", values, "pkVouchertype");
            return (Criteria) this;
        }

        public Criteria andPkVouchertypeNotIn(List<String> values) {
            addCriterion("PK_VOUCHERTYPE not in", values, "pkVouchertype");
            return (Criteria) this;
        }

        public Criteria andPkVouchertypeBetween(String value1, String value2) {
            addCriterion("PK_VOUCHERTYPE between", value1, value2, "pkVouchertype");
            return (Criteria) this;
        }

        public Criteria andPkVouchertypeNotBetween(String value1, String value2) {
            addCriterion("PK_VOUCHERTYPE not between", value1, value2, "pkVouchertype");
            return (Criteria) this;
        }

        public Criteria andPkBilltypeIsNull() {
            addCriterion("PK_BILLTYPE is null");
            return (Criteria) this;
        }

        public Criteria andPkBilltypeIsNotNull() {
            addCriterion("PK_BILLTYPE is not null");
            return (Criteria) this;
        }

        public Criteria andPkBilltypeEqualTo(String value) {
            addCriterion("PK_BILLTYPE =", value, "pkBilltype");
            return (Criteria) this;
        }

        public Criteria andPkBilltypeNotEqualTo(String value) {
            addCriterion("PK_BILLTYPE <>", value, "pkBilltype");
            return (Criteria) this;
        }

        public Criteria andPkBilltypeGreaterThan(String value) {
            addCriterion("PK_BILLTYPE >", value, "pkBilltype");
            return (Criteria) this;
        }

        public Criteria andPkBilltypeGreaterThanOrEqualTo(String value) {
            addCriterion("PK_BILLTYPE >=", value, "pkBilltype");
            return (Criteria) this;
        }

        public Criteria andPkBilltypeLessThan(String value) {
            addCriterion("PK_BILLTYPE <", value, "pkBilltype");
            return (Criteria) this;
        }

        public Criteria andPkBilltypeLessThanOrEqualTo(String value) {
            addCriterion("PK_BILLTYPE <=", value, "pkBilltype");
            return (Criteria) this;
        }

        public Criteria andPkBilltypeLike(String value) {
            addCriterion("PK_BILLTYPE like", value, "pkBilltype");
            return (Criteria) this;
        }

        public Criteria andPkBilltypeNotLike(String value) {
            addCriterion("PK_BILLTYPE not like", value, "pkBilltype");
            return (Criteria) this;
        }

        public Criteria andPkBilltypeIn(List<String> values) {
            addCriterion("PK_BILLTYPE in", values, "pkBilltype");
            return (Criteria) this;
        }

        public Criteria andPkBilltypeNotIn(List<String> values) {
            addCriterion("PK_BILLTYPE not in", values, "pkBilltype");
            return (Criteria) this;
        }

        public Criteria andPkBilltypeBetween(String value1, String value2) {
            addCriterion("PK_BILLTYPE between", value1, value2, "pkBilltype");
            return (Criteria) this;
        }

        public Criteria andPkBilltypeNotBetween(String value1, String value2) {
            addCriterion("PK_BILLTYPE not between", value1, value2, "pkBilltype");
            return (Criteria) this;
        }

        public Criteria andSrcsystemIsNull() {
            addCriterion("SRCSYSTEM is null");
            return (Criteria) this;
        }

        public Criteria andSrcsystemIsNotNull() {
            addCriterion("SRCSYSTEM is not null");
            return (Criteria) this;
        }

        public Criteria andSrcsystemEqualTo(String value) {
            addCriterion("SRCSYSTEM =", value, "srcsystem");
            return (Criteria) this;
        }

        public Criteria andSrcsystemNotEqualTo(String value) {
            addCriterion("SRCSYSTEM <>", value, "srcsystem");
            return (Criteria) this;
        }

        public Criteria andSrcsystemGreaterThan(String value) {
            addCriterion("SRCSYSTEM >", value, "srcsystem");
            return (Criteria) this;
        }

        public Criteria andSrcsystemGreaterThanOrEqualTo(String value) {
            addCriterion("SRCSYSTEM >=", value, "srcsystem");
            return (Criteria) this;
        }

        public Criteria andSrcsystemLessThan(String value) {
            addCriterion("SRCSYSTEM <", value, "srcsystem");
            return (Criteria) this;
        }

        public Criteria andSrcsystemLessThanOrEqualTo(String value) {
            addCriterion("SRCSYSTEM <=", value, "srcsystem");
            return (Criteria) this;
        }

        public Criteria andSrcsystemLike(String value) {
            addCriterion("SRCSYSTEM like", value, "srcsystem");
            return (Criteria) this;
        }

        public Criteria andSrcsystemNotLike(String value) {
            addCriterion("SRCSYSTEM not like", value, "srcsystem");
            return (Criteria) this;
        }

        public Criteria andSrcsystemIn(List<String> values) {
            addCriterion("SRCSYSTEM in", values, "srcsystem");
            return (Criteria) this;
        }

        public Criteria andSrcsystemNotIn(List<String> values) {
            addCriterion("SRCSYSTEM not in", values, "srcsystem");
            return (Criteria) this;
        }

        public Criteria andSrcsystemBetween(String value1, String value2) {
            addCriterion("SRCSYSTEM between", value1, value2, "srcsystem");
            return (Criteria) this;
        }

        public Criteria andSrcsystemNotBetween(String value1, String value2) {
            addCriterion("SRCSYSTEM not between", value1, value2, "srcsystem");
            return (Criteria) this;
        }

        public Criteria andIsmodifyIsNull() {
            addCriterion("ISMODIFY is null");
            return (Criteria) this;
        }

        public Criteria andIsmodifyIsNotNull() {
            addCriterion("ISMODIFY is not null");
            return (Criteria) this;
        }

        public Criteria andIsmodifyEqualTo(String value) {
            addCriterion("ISMODIFY =", value, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyNotEqualTo(String value) {
            addCriterion("ISMODIFY <>", value, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyGreaterThan(String value) {
            addCriterion("ISMODIFY >", value, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyGreaterThanOrEqualTo(String value) {
            addCriterion("ISMODIFY >=", value, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyLessThan(String value) {
            addCriterion("ISMODIFY <", value, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyLessThanOrEqualTo(String value) {
            addCriterion("ISMODIFY <=", value, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyLike(String value) {
            addCriterion("ISMODIFY like", value, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyNotLike(String value) {
            addCriterion("ISMODIFY not like", value, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyIn(List<String> values) {
            addCriterion("ISMODIFY in", values, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyNotIn(List<String> values) {
            addCriterion("ISMODIFY not in", values, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyBetween(String value1, String value2) {
            addCriterion("ISMODIFY between", value1, value2, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyNotBetween(String value1, String value2) {
            addCriterion("ISMODIFY not between", value1, value2, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmanualIsNull() {
            addCriterion("ISMANUAL is null");
            return (Criteria) this;
        }

        public Criteria andIsmanualIsNotNull() {
            addCriterion("ISMANUAL is not null");
            return (Criteria) this;
        }

        public Criteria andIsmanualEqualTo(String value) {
            addCriterion("ISMANUAL =", value, "ismanual");
            return (Criteria) this;
        }

        public Criteria andIsmanualNotEqualTo(String value) {
            addCriterion("ISMANUAL <>", value, "ismanual");
            return (Criteria) this;
        }

        public Criteria andIsmanualGreaterThan(String value) {
            addCriterion("ISMANUAL >", value, "ismanual");
            return (Criteria) this;
        }

        public Criteria andIsmanualGreaterThanOrEqualTo(String value) {
            addCriterion("ISMANUAL >=", value, "ismanual");
            return (Criteria) this;
        }

        public Criteria andIsmanualLessThan(String value) {
            addCriterion("ISMANUAL <", value, "ismanual");
            return (Criteria) this;
        }

        public Criteria andIsmanualLessThanOrEqualTo(String value) {
            addCriterion("ISMANUAL <=", value, "ismanual");
            return (Criteria) this;
        }

        public Criteria andIsmanualLike(String value) {
            addCriterion("ISMANUAL like", value, "ismanual");
            return (Criteria) this;
        }

        public Criteria andIsmanualNotLike(String value) {
            addCriterion("ISMANUAL not like", value, "ismanual");
            return (Criteria) this;
        }

        public Criteria andIsmanualIn(List<String> values) {
            addCriterion("ISMANUAL in", values, "ismanual");
            return (Criteria) this;
        }

        public Criteria andIsmanualNotIn(List<String> values) {
            addCriterion("ISMANUAL not in", values, "ismanual");
            return (Criteria) this;
        }

        public Criteria andIsmanualBetween(String value1, String value2) {
            addCriterion("ISMANUAL between", value1, value2, "ismanual");
            return (Criteria) this;
        }

        public Criteria andIsmanualNotBetween(String value1, String value2) {
            addCriterion("ISMANUAL not between", value1, value2, "ismanual");
            return (Criteria) this;
        }

        public Criteria andPreparedateIsNull() {
            addCriterion("PREPAREDATE is null");
            return (Criteria) this;
        }

        public Criteria andPreparedateIsNotNull() {
            addCriterion("PREPAREDATE is not null");
            return (Criteria) this;
        }

        public Criteria andPreparedateEqualTo(String value) {
            addCriterion("PREPAREDATE =", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateNotEqualTo(String value) {
            addCriterion("PREPAREDATE <>", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateGreaterThan(String value) {
            addCriterion("PREPAREDATE >", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateGreaterThanOrEqualTo(String value) {
            addCriterion("PREPAREDATE >=", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateLessThan(String value) {
            addCriterion("PREPAREDATE <", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateLessThanOrEqualTo(String value) {
            addCriterion("PREPAREDATE <=", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateLike(String value) {
            addCriterion("PREPAREDATE like", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateNotLike(String value) {
            addCriterion("PREPAREDATE not like", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateIn(List<String> values) {
            addCriterion("PREPAREDATE in", values, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateNotIn(List<String> values) {
            addCriterion("PREPAREDATE not in", values, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateBetween(String value1, String value2) {
            addCriterion("PREPAREDATE between", value1, value2, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateNotBetween(String value1, String value2) {
            addCriterion("PREPAREDATE not between", value1, value2, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPkPreparedIsNull() {
            addCriterion("PK_PREPARED is null");
            return (Criteria) this;
        }

        public Criteria andPkPreparedIsNotNull() {
            addCriterion("PK_PREPARED is not null");
            return (Criteria) this;
        }

        public Criteria andPkPreparedEqualTo(String value) {
            addCriterion("PK_PREPARED =", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedNotEqualTo(String value) {
            addCriterion("PK_PREPARED <>", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedGreaterThan(String value) {
            addCriterion("PK_PREPARED >", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedGreaterThanOrEqualTo(String value) {
            addCriterion("PK_PREPARED >=", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedLessThan(String value) {
            addCriterion("PK_PREPARED <", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedLessThanOrEqualTo(String value) {
            addCriterion("PK_PREPARED <=", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedLike(String value) {
            addCriterion("PK_PREPARED like", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedNotLike(String value) {
            addCriterion("PK_PREPARED not like", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedIn(List<String> values) {
            addCriterion("PK_PREPARED in", values, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedNotIn(List<String> values) {
            addCriterion("PK_PREPARED not in", values, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedBetween(String value1, String value2) {
            addCriterion("PK_PREPARED between", value1, value2, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedNotBetween(String value1, String value2) {
            addCriterion("PK_PREPARED not between", value1, value2, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNull() {
            addCriterion("USE_STATE is null");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNotNull() {
            addCriterion("USE_STATE is not null");
            return (Criteria) this;
        }

        public Criteria andUseStateEqualTo(String value) {
            addCriterion("USE_STATE =", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotEqualTo(String value) {
            addCriterion("USE_STATE <>", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThan(String value) {
            addCriterion("USE_STATE >", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThanOrEqualTo(String value) {
            addCriterion("USE_STATE >=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThan(String value) {
            addCriterion("USE_STATE <", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThanOrEqualTo(String value) {
            addCriterion("USE_STATE <=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLike(String value) {
            addCriterion("USE_STATE like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotLike(String value) {
            addCriterion("USE_STATE not like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateIn(List<String> values) {
            addCriterion("USE_STATE in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotIn(List<String> values) {
            addCriterion("USE_STATE not in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateBetween(String value1, String value2) {
            addCriterion("USE_STATE between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotBetween(String value1, String value2) {
            addCriterion("USE_STATE not between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNull() {
            addCriterion("CREATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNotNull() {
            addCriterion("CREATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserEqualTo(String value) {
            addCriterion("CREATE_USER =", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotEqualTo(String value) {
            addCriterion("CREATE_USER <>", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThan(String value) {
            addCriterion("CREATE_USER >", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThanOrEqualTo(String value) {
            addCriterion("CREATE_USER >=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThan(String value) {
            addCriterion("CREATE_USER <", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThanOrEqualTo(String value) {
            addCriterion("CREATE_USER <=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLike(String value) {
            addCriterion("CREATE_USER like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotLike(String value) {
            addCriterion("CREATE_USER not like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserIn(List<String> values) {
            addCriterion("CREATE_USER in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotIn(List<String> values) {
            addCriterion("CREATE_USER not in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserBetween(String value1, String value2) {
            addCriterion("CREATE_USER between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotBetween(String value1, String value2) {
            addCriterion("CREATE_USER not between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNull() {
            addCriterion("UPDATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNotNull() {
            addCriterion("UPDATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserEqualTo(String value) {
            addCriterion("UPDATE_USER =", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotEqualTo(String value) {
            addCriterion("UPDATE_USER <>", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThan(String value) {
            addCriterion("UPDATE_USER >", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER >=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThan(String value) {
            addCriterion("UPDATE_USER <", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER <=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLike(String value) {
            addCriterion("UPDATE_USER like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotLike(String value) {
            addCriterion("UPDATE_USER not like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIn(List<String> values) {
            addCriterion("UPDATE_USER in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotIn(List<String> values) {
            addCriterion("UPDATE_USER not in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserBetween(String value1, String value2) {
            addCriterion("UPDATE_USER between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotBetween(String value1, String value2) {
            addCriterion("UPDATE_USER not between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("UPDATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("UPDATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("UPDATE_TIME =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("UPDATE_TIME <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("UPDATE_TIME >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("UPDATE_TIME <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("UPDATE_TIME in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("UPDATE_TIME not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("REMARK is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("REMARK is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("REMARK =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("REMARK <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("REMARK >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("REMARK >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("REMARK <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("REMARK <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("REMARK like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("REMARK not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("REMARK in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("REMARK not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("REMARK between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("REMARK not between", value1, value2, "remark");
            return (Criteria) this;
        }
    }

    /**
     *  * cw_bd_vouchtemp
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * cw_bd_vouchtemp 2019-07-31
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}